\documentclass{beamer}
\usepackage{graphicx}
\usepackage{underscore}

\DeclareUrlCommand\email{}

\beamertemplatenavigationsymbolsempty
\addtolength{\oddsidemargin}{-7mm}
\addtolength{\textwidth}{14mm}

\title{dconf in a git \$HOME}
\author[Josh Triplett]{Josh Triplett\\\email{josh@joshtriplett.org}}
\date{DebConf 2014}

\hypersetup{pdftitle={dconf in a git \$HOME},pdfauthor={Josh Triplett}}

\begin{document}
\maketitle

\frame{\centering \LARGE git \$HOME}
\frame{\centering \LARGE meh}
\frame{\centering \LARGE GNOME 2}
\frame{\centering \LARGE gconf}

\begin{frame}[fragile]
\LARGE
\begin{verbatim}
~$ git ls-files '*gconf*'
.gconf.path
.gconf.shared/%gconf-tree.xml
\end{verbatim}
\end{frame}

\begin{frame}[fragile]
\LARGE \ttfamily
\~\$ cat \~{}/.gconf.path\
xml:readonly:\$(HOME)/.gconf.shared

\end{frame}

\begin{frame}[fragile]
\LARGE
\begin{verbatim}
~$ cat .gconf.shared/%gconf-tree.xml
<?xml version="1.0"?>
<gconf>
  <dir name="apps">
    <dir name="gnome-screensaver">
      <entry name="lock_enabled"
             mtime="1320604993"
             type="bool" value="true"
      />
\end{verbatim}
\vdots
\end{frame}

\frame{\centering \LARGE This mostly worked}

\begin{frame}[fragile]
\LARGE
\begin{center}
Difficult to edit:
\end{center}

\begin{ttfamily}
\~\$ cat .gconf.path 
xml:\alert{readonly}:\$(HOME)/.gconf.shared
\end{ttfamily}

\end{frame}

\frame{\centering \LARGE Restart to apply changes}

\frame{\centering \LARGE GNOME 3}
\frame{\centering \LARGE dconf}
\frame{\centering \LARGE No user .dconf.path}
\frame{\centering \LARGE root}
\frame{\centering \LARGE \texttt{/etc}}
\frame{\centering \LARGE \texttt{\$HOME}}

\begin{frame}[fragile]
  \begin{center}
    \begin{LARGE}
\begin{verbatim}
~$ file ~/.config/dconf/user
/home/josh/.config/dconf/user:
GVariant Database file, version 0
\end{verbatim}
      \vspace{\baselineskip}
      \pause
      \begin{itemize}
      \item Binary
        \pause
      \item Fast
      \item No round-trip to dconf-service for reads
        \pause
      \item How do I deal with this in git?
      \end{itemize}
    \end{LARGE}
  \end{center}
\end{frame}

\frame{\centering \LARGE IRC \#dconf}
\frame{\centering \LARGE Ryan Lortie (desrt) is awesome}
\frame{\centering \LARGE Stacked user databases}
\frame{\centering \LARGE User profiles}

\begin{frame}[fragile]
\LARGE
\begin{verbatim}
~$ git ls-files '*dconf*'
.config/dconf/profile
.config/dconf/profile-edit
.config/dconf/user.txt
.config/dconfd-ignore
.local/bin/dconf-list-recursively
.local/bin/dconfc
.local/bin/dconfd
.local/bin/dconfe
\end{verbatim}
\end{frame}

\begin{frame}[fragile]
\LARGE
\begin{verbatim}
~$ echo $DCONF_PROFILE
/home/josh/.config/dconf/profile
\end{verbatim}
\end{frame}

\begin{frame}[fragile]
\LARGE
\begin{verbatim}
~$ cat $DCONF_PROFILE
user-db:user
service-db:keyfile/user
\end{verbatim}
\end{frame}

\begin{frame}[fragile]
\LARGE
\begin{verbatim}
~$ cat .config/dconf/user.txt
[org/gnome/desktop/background]
color-shading-type='solid'
picture-options='none'
primary-color='#4682b4'

[org/gnome/desktop/interface]
clock-format='12h'
clock-show-date=true
cursor-blink=false
\end{verbatim}
\vdots
\end{frame}

\begin{frame}[fragile]
\LARGE
\begin{verbatim}
~$ cat .config/dconf/profile-edit
service-db:keyfile/user
\end{verbatim}
\end{frame}

\begin{frame}[fragile]
\Large
\begin{verbatim}
~$ cat .local/bin/dconfe
#!/bin/sh
DCONF_PROFILE="${DCONF_PROFILE}-edit" exec "$@"
\end{verbatim}
\end{frame}

\begin{frame}[fragile]
\LARGE
\begin{verbatim}
~$ dconfe gsettings set ...
~$ dconfe gsettings reset ...
\end{verbatim}
\pause
\begin{verbatim}
~$ dconfe gnome-control-center
~$ dconfe gnome-tweak-tool
~$ dconfe gnome-terminal
\end{verbatim}
\end{frame}

\begin{frame}[fragile]
\LARGE
\begin{verbatim}
~$ head -n2 .local/bin/dconfd
#!/usr/bin/python
import fnmatch, os, subprocess, sys
\end{verbatim}
\end{frame}

\begin{frame}[fragile]
\large
\begin{ttfamily}
\~\$ dconfd \\
--- service-db \\
+++ user-db \\
- /org/gnome/desktop/background/primary-color '\#4682b4' \\
+ /org/gnome/desktop/background/primary-color '\#000000'
\end{ttfamily}

\end{frame}

\begin{frame}[fragile]
\large
\begin{ttfamily}
\~\$ dconfd | colordiff \\
\textcolor{red}{--- service-db} \\
\textcolor{blue}{+++ user-db} \\
\textcolor{red}{- /org/gnome/desktop/background/primary-color '\#4682b4'} \\
\textcolor{blue}{+ /org/gnome/desktop/background/primary-color '\#000000'}
\end{ttfamily}

\end{frame}

\begin{frame}[fragile]
\Large
\begin{verbatim}
~$ dconfc /org/gnome/desktop/background/
\end{verbatim}
\pause
\begin{verbatim}
~$ git add .config/dconf/user.txt
~$ git commit -m 'Boring background'
\end{verbatim}
\end{frame}

\begin{frame}[fragile]
\Large
\begin{verbatim}
~$ dconf-list-recursively /org/gnome/charmap/
/org/gnome/charmap/window-state/size
/org/gnome/charmap/window-state/maximized
/org/gnome/charmap/last-char
/org/gnome/charmap/group-by
\end{verbatim}
\end{frame}

\begin{frame}[fragile]
\Large
\begin{verbatim}
~$ cat .config/dconfd-ignore 
/apps/seahorse/*
/ca/desrt/dconf-editor/*
/org/gnome/Totem/*
/org/gnome/charmap/*
/org/gnome/cheese/*
\end{verbatim}
\vdots
\end{frame}

\frame{\centering \LARGE inotify}
\frame{\centering \LARGE Changes applied immediately}

\frame{\centering \LARGE \texttt{git://joshtriplett.org/git/home}}

\end{document}